diff -uNrd ircd-hybrid-6.2/src/m_rehash.c ircd-hyb6.2-FEFr5/src/m_rehash.c
--- ircd-hybrid-6.2/src/m_rehash.c	Sun Jun 17 19:51:21 2001
+++ ircd-hyb6.2-FEFr5/src/m_rehash.c	Tue Aug 21 01:39:35 2001
@@ -117,11 +117,7 @@
       if (irccmp(parv[1],"DNS") == 0)
         {
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0], "DNS");
-#ifdef CUSTOM_ERR
-          sendto_ops("%s is rehashing DNS while whistling innocently",
-#else
           sendto_ops("%s is rehashing DNS",
-#endif
                  parv[0]);
           restart_resolver();   /* re-read /etc/resolv.conf AGAIN?
                                    and close/re-open res socket */
@@ -137,11 +133,7 @@
 		    }
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0], "temp klines");
           flush_temp_klines();
-#ifdef CUSTOM_ERR
-          sendto_ops("%s is clearing temp klines while whistling innocently",
-#else
           sendto_ops("%s is clearing temp klines",
-#endif
                  parv[0]);
           found = YES;
         }
@@ -158,11 +150,7 @@
 
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0], "g-lines");
           flush_glines();
-#ifdef CUSTOM_ERR
-          sendto_ops("%s is clearing G-lines while whistling innocently",
-#else
           sendto_ops("%s is clearing G-lines",
-#endif
                  parv[0]);
           found = YES;
         }
@@ -171,11 +159,7 @@
         {
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0], "garbage collecting");
           block_garbage_collect();
-#ifdef CUSTOM_ERR
-          sendto_ops("%s is garbage collecting while whistling innocently",
-#else
           sendto_ops("%s is garbage collecting",
-#endif
                  parv[0]);
           found = YES;
         }
@@ -208,11 +192,7 @@
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0],
                      ConfigFileEntry.configfile);
           /* this does a full rehash right now, so report it as such */
-#ifdef CUSTOM_ERR
-          sendto_ops("%s is rehashing dlines from server config file while whistling innocently",
-#else
           sendto_ops("%s is rehashing dlines from server config file",
-#endif
                      parv[0]);
           log(L_NOTICE, "REHASH From %s\n", get_client_name(sptr, HIDE_IP));
           dline_in_progress = 1;
@@ -227,11 +207,11 @@
       else
         {
 #ifdef GLINES
-          sendto_one(sptr, ":%s NOTICE %s :Rehash one of: DNS, TKLINES, GLINES, GC, HELP, MOTD, OMOTD, DUMP",
-	                 me.name, sptr->name);
+	sendto_one(sptr, ":%s NOTICE %s :Rehash one of: DNS, TKLINES, GLINES, GC, HELP, MOTD, OMOTD, DUMP",
+		   me.name, sptr->name);
 #else
-          sendto_one(sptr, ":%s NOTICE %s :Rehash one of: DNS, TKLINES, GC, HELP, MOTD, OMOTD, DUMP", 
-	                 me.name, sptr->name);
+	sendto_one(sptr, ":%s NOTICE %s :Rehash one of: DNS, TKLINES, GC, HELP, MOTD, OMOTD, DUMP",
+		   me.name, sptr->name);
 #endif
           return(0);
         }
@@ -240,11 +220,7 @@
     {
       sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0],
                  ConfigFileEntry.configfile);
-#ifdef CUSTOM_ERR
-      sendto_ops("%s is rehashing server config file while whistling innocently",
-#else
       sendto_ops("%s is rehashing server config file",
-#endif
                  parv[0]);
       log(L_NOTICE, "REHASH From %s\n", get_client_name(sptr, SHOW_IP));
       return rehash(cptr, sptr, 0);
diff -uNrd ircd-hybrid-6.2/src/m_server.c ircd-hyb6.2-FEFr5/src/m_server.c
--- ircd-hybrid-6.2/src/m_server.c	Sun Jun 17 19:51:21 2001
+++ ircd-hyb6.2-FEFr5/src/m_server.c	Tue Aug 21 02:04:32 2001
@@ -164,24 +164,23 @@
        */
       if (IsServer(cptr))
         {
-		  /* heh, obviously we've never encountered this condition ..
-		   * get_client_name returns a little sumpin-sumpin static, we
-		   * can't use it twice here. -gnp */
-        char nbuf[HOSTLEN * 2 + USERLEN + 5]; /* same size as in s_misc.c */
+		/* heh, obviously we've never encountered this condition ..
+		 * get_client_name returns a little sumpin-sumpin static, we
+		 * can't use it twice here. -gnp */
+	char nbuf[HOSTLEN * 2 + USERLEN + 5]; /* same size as in s_misc.c */
 
 #ifdef HIDE_SERVERS_IPS
 		strcpy(nbuf, get_client_name(sptr,MASK_IP));
 #else
 		strcpy(nbuf, get_client_name(sptr,SHOW_IP));
 #endif
-
           sendto_realops("SERVER command from remote user %s -- %s is a hacked server",
-	                 nbuf, 
+			 nbuf,
 #ifdef HIDE_SERVERS_IPS
-	                 get_client_name(cptr,MASK_IP));
-#else							      
-                     get_client_name(cptr,SHOW_IP));
-#endif			  
+			 get_client_name(cptr,MASK_IP));
+#else
+			 get_client_name(cptr,SHOW_IP));
+#endif
         }
       else
         {
@@ -464,6 +463,18 @@
 #endif		 
       return exit_client(cptr, cptr, cptr, "Non-TS server");
     }
+
+#ifdef FEF_ONLY
+  /*
+   * Reject the server if we did not get a CAPAB stating that this
+   * server supports the FEFnet protocol -Jail Bird
+   */
+  if(!IsCapable(cptr,CAP_FEF)) {
+	sendto_ops("Link %s dropped, non-FEF server",
+		   get_client_name(cptr, TRUE));
+	return exit_client(cptr, cptr, cptr, "Non-FEF server");
+  }
+#endif
 
   /*
    * if we are connecting (Handshake), we already have the name from the
diff -uNrd ircd-hybrid-6.2/src/m_stats.c ircd-hyb6.2-FEFr5/src/m_stats.c
--- ircd-hybrid-6.2/src/m_stats.c	Tue Jul 17 21:37:14 2001
+++ ircd-hyb6.2-FEFr5/src/m_stats.c	Mon Aug 20 23:32:39 2001
@@ -421,11 +421,19 @@
       valid_stats++;
       break;
 
-    case 'S' : case 's':
+    case 'S' :
       if (IsAnOper(sptr))
-        list_scache(cptr,sptr,parc,parv);
+          report_specials(sptr,CONF_SLINE,RPL_STATSSLINE);
       else
         sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      valid_stats++;
+      break;
+
+    case 's':
+      if (IsAnOper(sptr))
+	  list_scache(cptr,sptr,parc,parv);
+      else
+	  sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       valid_stats++;
       break;
 
diff -uNrd ircd-hybrid-6.2/src/m_who.c ircd-hyb6.2-FEFr5/src/m_who.c
--- ircd-hybrid-6.2/src/m_who.c	Fri Nov 24 12:36:30 2000
+++ ircd-hyb6.2-FEFr5/src/m_who.c	Thu Jan  4 01:37:18 2001
@@ -199,7 +199,11 @@
       chptr = hash_find_channel(channame, NULL);
       if (chptr)
         {
-          member = IsMember(sptr, chptr);
+          member = IsMember(sptr, chptr)
+#ifdef OPERS_SEE_INVISIBLE
+		   || IsAnOper(sptr);
+#endif
+		   ;
           if (member || !SecretChannel(chptr))
             for (lp = chptr->members; lp; lp = lp->next)
               {
@@ -218,7 +222,12 @@
       int isinvis = 0;
       struct Channel *ch2ptr = NULL;
 
-      isinvis = IsInvisible(acptr);
+      isinvis = IsInvisible(acptr)
+#ifdef OPERS_SEE_INVISIBLE
+	&& !IsAnOper(sptr)
+#endif
+	;
+
       for (lp = acptr->user->channel; lp; lp = lp->next)
         {
           chptr = lp->value.chptr;
@@ -244,6 +253,12 @@
         continue;
       
       showperson = 0;
+#ifdef OPERS_SEE_INVISIBLE
+	/* Allow IRCops to see invisible users. --Runt */
+	if (IsAnOper(sptr))
+	  showperson = 1;
+#endif
+
       /*
        * Show user if they are on the same channel, or not
        * invisible and on a non secret channel (if any).
@@ -255,7 +270,11 @@
       for (lp = acptr->user->channel; lp; lp = lp->next)
         {
           chptr = lp->value.chptr;
-          member = IsMember(sptr, chptr);
+          member = IsMember(sptr, chptr)
+#ifdef OPERS_SEE_INVISIBLE
+		   || IsAnOper(sptr);
+#endif
+		   ;
           if (isinvis && !member)
             continue;
           if (member || (!isinvis && PubChannel(chptr)))
diff -uNrd ircd-hybrid-6.2/src/m_whois.c ircd-hyb6.2-FEFr5/src/m_whois.c
--- ircd-hybrid-6.2/src/m_whois.c	Wed Jun  6 02:56:34 2001
+++ ircd-hyb6.2-FEFr5/src/m_whois.c	Mon Aug 20 23:32:39 2001
@@ -126,6 +126,7 @@
   char  *p = NULL;
   int   found, len, mlen;
   static time_t last_used=0L;
+  static char tempinfo[BUFSIZE+1];
   int found_mode;
 
   if (parc < 2)
@@ -219,9 +220,19 @@
 
           a2cptr = find_server(user->server);
           
+          /* Okay. Let's redo this one. The old code would show the IP
+             if the client was local. Since giving this information to
+             everybody would defeat the purpose for I:-line spoofing,
+             let's only give it out to IRCops. -JailBird */
+          if (MyClient(acptr) && IsAnOper(sptr))
+              sprintf(tempinfo,"%s (%s)",acptr->info,
+                      inetntoa((char *)&acptr->ip));
+          else
+              strncpy_irc(tempinfo,acptr->info, BUFSIZE);
+
           sendto_one(sptr, form_str(RPL_WHOISUSER), me.name,
                      parv[0], name,
-                     acptr->username, acptr->host, acptr->info);
+                     acptr->username, acptr->host, tempinfo);
 
           mlen = strlen(me.name) + strlen(parv[0]) + 6 +
             strlen(name);
@@ -284,8 +295,11 @@
             sendto_one(sptr, form_str(RPL_WHOISOPERATOR),
                        me.name, parv[0], name);
 #ifdef WHOIS_NOTICE
-          if ((MyOper(acptr)) && ((acptr)->umodes & FLAGS_SPY) &&
-              (MyConnect(sptr)) && (IsPerson(sptr)) && (acptr != sptr))
+          if ((MyOper(acptr)) && ((acptr)->umodes & FLAGS_SPY)
+#ifndef REMOTE_WHOIS
+              && (MyConnect(sptr))
+#endif
+              && (IsPerson(sptr)) && (acptr != sptr))
             sendto_one(acptr,
                        ":%s NOTICE %s :*** Notice -- %s (%s@%s) is doing a /whois on you.",
                        me.name, acptr->name, parv[0], sptr->username,
@@ -342,7 +356,11 @@
           name = (!*acptr->name) ? "?" : acptr->name;
           invis = IsInvisible(acptr);
           member = (user->channel) ? 1 : 0;
-          showperson = (wilds && !invis && !member) || !wilds;
+          showperson = (wilds && !invis && !member) || !wilds
+#ifdef OPERS_SEE_INVISIBLE
+		       || IsAnOper(sptr)
+#endif
+		       ;
           for (lp = user->channel; lp; lp = lp->next)
             {
               chptr = lp->value.chptr;
@@ -363,9 +381,19 @@
           
           a2cptr = find_server(user->server);
           
+          /* Okay. Let's redo this one. The old code would show the IP
+             if the client was local. Since giving this information to
+             everybody would defeat the purpose for I:-line spoofing,
+             let's only give it out to IRCops. -JailBird */
+          if (MyClient(acptr) && IsAnOper(sptr))
+              sprintf(tempinfo,"%s (%s)",acptr->info,
+                      inetntoa((char *)&acptr->ip));
+          else
+              strncpy_irc(tempinfo,acptr->info, BUFSIZE);
+
           sendto_one(sptr, form_str(RPL_WHOISUSER), me.name,
                      parv[0], name,
-                     acptr->username, acptr->host, acptr->info);
+                     acptr->username, acptr->host, tempinfo);
           found = 1;
           mlen = strlen(me.name) + strlen(parv[0]) + 6 +
             strlen(name);
@@ -428,7 +456,11 @@
                        me.name, parv[0], name);
 #ifdef WHOIS_NOTICE
           if ((MyOper(acptr)) && ((acptr)->umodes & FLAGS_SPY) &&
-              (MyConnect(sptr)) && (IsPerson(sptr)) && (acptr != sptr))
+              IsPerson(sptr) && (acptr != sptr)
+#ifndef REMOTE_WHOIS
+	      && (MyConnect(sptr))
+#endif
+	      )
             sendto_one(acptr,
                        ":%s NOTICE %s :*** Notice -- %s (%s@%s) is doing a /whois on you.",
                        me.name, acptr->name, parv[0], sptr->username,
diff -uNrd ircd-hybrid-6.2/src/messages.tab ircd-hyb6.2-FEFr5/src/messages.tab
--- ircd-hybrid-6.2/src/messages.tab	Mon Jul  2 05:19:45 2001
+++ ircd-hyb6.2-FEFr5/src/messages.tab	Sun Sep 30 20:22:50 2001
@@ -24,7 +24,7 @@
 
 static  char *  replies[] = {
 /* 000 */       (char *)NULL,
-/* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to the Internet Relay Network %s",
+/* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to %s, %s!!!",
 /* 002  RPL_YOURHOST,*/ ":%s 002 %s :Your host is %s, running version %s",
 /* 003  RPL_CREATED, */ ":%s 003 %s :This server was created %s",
 /* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oOiwszcrkfydnxb biklmnopstve",
@@ -38,9 +38,9 @@
 /* 012 */       (char *)NULL,
 /* 013 */       (char *)NULL,
 /* 014 */       (char *)NULL,
-/* 015 */       (char *)NULL,
-/* 016 */       (char *)NULL,
-/* 017 */       (char *)NULL,
+/* 015 */	(char *)NULL,
+/* 016 */	(char *)NULL,
+/* 017 */	(char *)NULL,
 /* 018 */       (char *)NULL,
 /* 019 */       (char *)NULL,
 /* 020 */       (char *)NULL,
@@ -240,7 +240,7 @@
 /* 214 RPL_STATSNLINE, */       ":%s 214 %s %c %s * %s %d %d",
 /* 215 RPL_STATSILINE, */       ":%s 215 %s %c %s * %s@%s %d %d",
 /* 216 RPL_STATSKLINE, */       ":%s 216 %s %c %s * %s %s",
-/* 217 RPL_STATSQLINE, */       ":%s 217 %s %s %s %s@%s",
+/* 217 RPL_STATSQLINE, */       ":%s 217 %s %s %s@%s :%s",
 /* 218 RPL_STATSYLINE, */       ":%s 218 %s %c %d %d %d %d %lu",
 /* 219 RPL_ENDOFSTATS, */       ":%s 219 %s %c :End of /STATS report",
 /* 220 RPL_STATSPLINE, */       ":%s 220 %s %c %d %s %d :%s",
@@ -268,8 +268,8 @@
 /* 242 RPL_STATSUPTIME,*/       ":%s 242 %s :Server Up %d days, %d:%02d:%02d",
 /* 243 RPL_STATSOLINE, */       ":%s 243 %s %c %s@%s * %s %s %d %s",
 /* 244 RPL_STATSHLINE, */       ":%s 244 %s %c %s * %s %d %d", 
-/* 245 RPL_STATSSLINE, */       ":%s 245 %s %c %s * %s %d %d", 
-/* 246 */       (char *)NULL,
+/* 245 RPL_STATSSLINE, */       ":%s 245 %s %s %s * * 0 0",
+/* 246 */	(char *)NULL,
 /* 247 RPL_STATSXLINE, */       ":%s 247 %s %s %s * * 0 0",
 
 /* 248 RPL_STATSULINE, */       ":%s 248 %s %s %s",
@@ -360,11 +360,7 @@
 /* 330 */       (char *)NULL,
 /* 331 RPL_NOTOPIC, */          ":%s 331 %s %s :No topic is set.",
 /* 332 RPL_TOPIC, */            ":%s 332 %s %s :%s",
-#ifdef TOPIC_INFO
 /* 333 RPL_TOPICWHOTIME, */     ":%s 333 %s %s %s %lu",
-#else
-/* 333 */       (char *)NULL,
-#endif
 /* 334 */       (char *)NULL,
 /* 335 */       (char *)NULL,
 /* 336 */       (char *)NULL,
@@ -448,7 +444,7 @@
 /* 406 ERR_WASNOSUCHNICK, */    ":%s 406 %s %s :There was no such nickname",
 /* 407 ERR_TOOMANYTARGETS, */
                 ":%s 407 %s %s :Too many recipients. Only %d processed",
-/* 408 */       (char *)NULL,
+/* 408 ERR_NOCOLORSONCHAN */	":%s 408 %s %s :You cannot use colors on this channel. Not sent: %s",
 /* 409 ERR_NOORIGIN, */         ":%s 409 %s :No origin specified",
 /* 410 */       (char *)NULL,
 /* 411 ERR_NORECIPIENT, */      ":%s 411 %s :No recipient given (%s)",
@@ -478,9 +474,9 @@
 /* 434 */       (char *)NULL,
 /* 435 */       (char *)NULL,
 /* 436 ERR_NICKCOLLISION, */    ":%s 436 %s %s :Nickname collision KILL",
-/* 437 ERR_UNAVAILRESOURCE, */  ":%s 437 %s %s :Nick/channel is temporarily unavailable",
-/* 438 ERR_NICKTOOFAST */       ":%s 438 %s %s %s :Nick change too fast. Please wait %d seconds.",
-/* 439 */       (char *)NULL,
+/* 437 ERR_UNAVAILRESOURCE, */	":%s 437 %s %s :Nick/channel is temporarily unavailable",
+/* 438 ERR_NICKTOOFAST */	":%s 438 %s %s %s :Nick change too fast. Please wait %d seconds.",
+/* 439 ERR_BANNICKCHANGE, */	":%s 438 %s %s :Cannot change nickname while banned on channel",
 /* 440 */       (char *)NULL,
 /* 441 ERR_USERNOTINCHANNEL, */ ":%s 441 %s %s %s :They aren't on that channel",
 /* 442 ERR_NOTONCHANNEL, */     ":%s 442 %s %s :You're not on that channel",
diff -uNrd ircd-hybrid-6.2/src/mtrie_conf.c ircd-hyb6.2-FEFr5/src/mtrie_conf.c
--- ircd-hybrid-6.2/src/mtrie_conf.c	Tue Jul 17 22:30:33 2001
+++ ircd-hyb6.2-FEFr5/src/mtrie_conf.c	Mon Aug 20 23:32:42 2001
@@ -1601,7 +1601,7 @@
  * Clear out the mtrie list and the unsortable list (recursively)
  */
 
-void clear_mtrie_conf_links()
+void clear_mtrie_conf_links(void)
 {
   aConfItem *found_conf;
   aConfItem *found_conf_next;
diff -uNrd ircd-hybrid-6.2/src/numeric.c ircd-hyb6.2-FEFr5/src/numeric.c
--- ircd-hybrid-6.2/src/numeric.c	Wed Jul 28 18:27:46 1999
+++ ircd-hyb6.2-FEFr5/src/numeric.c	Tue Aug 21 01:55:57 2001
@@ -27,12 +27,7 @@
 
 #include <assert.h>
 
-#ifdef CUSTOM_ERR            /* ZZZZ ick */
-#include "messages_cust.tab"
-#else
 #include "messages.tab"
-#endif
-
 
 /*
  * The observant will note that err_str and rpl_str
diff -uNrd ircd-hybrid-6.2/src/opers.motd ircd-hyb6.2-FEFr5/src/opers.motd
--- ircd-hybrid-6.2/src/opers.motd	Wed Dec 31 19:00:00 1969
+++ ircd-hyb6.2-FEFr5/src/opers.motd	Mon Sep 11 01:08:51 2000
@@ -0,0 +1 @@
+WELCOME, YOU SEXY IRCOP STUD YOU!!!
diff -uNrd ircd-hybrid-6.2/src/oratime.c ircd-hyb6.2-FEFr5/src/oratime.c
--- ircd-hybrid-6.2/src/oratime.c	Wed Dec 31 19:00:00 1969
+++ ircd-hyb6.2-FEFr5/src/oratime.c	Thu Jan  4 01:37:20 2001
@@ -0,0 +1,68 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, src/oratime.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: oratime.c,v 1.3 2000/11/18 19:11:13 lusky Exp $
+ */
+#include "oratime.h"
+#ifdef ORATIMING
+
+#include "client.h"
+#include "send.h"
+
+#include <sys/time.h>
+
+static struct timeval tsdnow;
+static struct timeval tsdthen;
+static unsigned int   tsdms;
+
+/*
+ * Timing stuff (for performance measurements): compile with -DORATIMING
+ *   and put a TMRESET where you want the counter of time spent set to 0,
+ *  a TMPRINT where you want the accumulated results, and TMYES/TMNO pairs
+ *  around the parts you want timed -orabidoo
+ */
+void orat_reset(void)
+{
+  tsdms = 0;
+}
+
+void orat_yes(void)
+{
+  gettimeofday(&tsdthen, 0);
+}
+
+void orat_no(void)
+{
+  gettimeofday(&tsdnow, 0); 
+  if (tsdnow.tv_sec != tsdthen.tv_sec) 
+    tsdms += 1000000 * (tsdnow.tv_sec - tsdthen.tv_sec); 
+  tsdms += tsdnow.tv_usec;
+  tsdms -= tsdthen.tv_usec;
+}
+
+void orat_report(void)
+{
+  sendto_realops("Time spent: %ld ms", tsdms);
+}
+
+#endif /* ORATIMING */
+
diff -uNrd ircd-hybrid-6.2/src/s_conf.c ircd-hyb6.2-FEFr5/src/s_conf.c
--- ircd-hybrid-6.2/src/s_conf.c	Sun Aug  5 14:40:52 2001
+++ ircd-hyb6.2-FEFr5/src/s_conf.c	Sun Sep 30 20:23:18 2001
@@ -144,6 +144,9 @@
 /* conf uline link list root */
 struct ConfItem        *u_conf = ((struct ConfItem *)NULL);
 
+/* conf sline link list root */
+struct ConfItem        *s_conf = ((struct ConfItem *)NULL);
+
 /* keep track of .include files to hash in */
 struct ConfItem        *include_list = ((struct ConfItem *)NULL);
 
@@ -378,6 +381,8 @@
     this_conf = x_conf;
   else if (flags & CONF_ULINE)
     this_conf = u_conf;
+  else if (flags & CONF_SLINE)
+    this_conf = s_conf;
   else return;
 
   for (aconf = this_conf; aconf; aconf = aconf->next)
@@ -388,7 +393,11 @@
         sendto_one(sptr, form_str(numeric),
                    me.name,
                    sptr->name,
-                   name,
+		   host,
+		   pass,
+		   name,
+		   port,
+                   user,
                    pass);
       }
 }
@@ -701,7 +710,7 @@
         {
           if (IsGotId(this_client))
             {
-              if(!irccmp(ptr->value.cptr->username,username))
+                if(!irccmp(ptr->value.cptr->username,username))
                   count++;
             }
           else
@@ -1376,7 +1385,9 @@
   if(mask & CONF_XLINE)
     this_conf = x_conf;
   else if(mask & CONF_ULINE)
-    this_conf = u_conf;
+    this_conf = u_conf; 
+  else if(mask & CONF_SLINE)
+    this_conf = s_conf;
   else
     return((struct ConfItem *)NULL);
 
@@ -1497,7 +1508,7 @@
           get_printable_conf(aconf, &name, &host, &pass, &user, &port);
           
           sendto_one(sptr, form_str(RPL_STATSQLINE),
-                     me.name, sptr->name, name, pass, user, host);
+                     me.name, sptr->name, name, user, host, pass);
         }
     }
 }
@@ -2048,8 +2059,13 @@
           aconf->status = CONF_QUARANTINED_NICK;
           break;
 
-        case 'U': /* Uphost, ie. host where client reading */
-        case 'u': /* this should connect.                  */
+        case 'S':
+        case 's':
+          aconf->status = CONF_SLINE;
+          break;
+
+        case 'U':
+        case 'u':
           aconf->status = CONF_ULINE;
           break;
 
@@ -2448,6 +2464,16 @@
           aconf->next = u_conf;
           u_conf = aconf;
         }
+      else if (aconf->status & CONF_SLINE)
+        {
+          dontadd = 1;
+          MyFree(aconf->user);
+          aconf->user = (char *)NULL;
+          MyFree(aconf->name);
+	  DupString(aconf->name, aconf->host);
+          aconf->next = s_conf;
+          s_conf = aconf;
+        }
       else if (aconf->status & CONF_QUARANTINED_NICK)
         {
           dontadd = 1;
@@ -3029,6 +3055,7 @@
  * side effects  -
  * return as string, the oper privs as derived from port
  * also, set the oper privs if given cptr non NULL
+      *privs_ptr++ = 'K';
  */
 
 char *oper_privs_as_string(aClient *cptr,int port)
@@ -3052,7 +3079,7 @@
     {
       if(cptr)
         SetOperK(cptr);
-      *privs_ptr++ = 'K';
+	*privs_ptr++ = 'K';
     }
   else
     *privs_ptr++ = 'k';
@@ -3382,7 +3409,7 @@
  *
  * side effects - command to test I/K lines on server
  *
- * i.e. /quote testline user@host,ip
+ * i.e. /quote testline user@host|ip
  *
  */
 
@@ -3412,9 +3439,9 @@
               if( aconf )
                 {
                   get_printable_conf(aconf, &name, &host, &pass, &user, &port);
-                  sendto_one(sptr, 
+                  sendto_one(sptr,
                          ":%s NOTICE %s :D-line host [%s] pass [%s]",
-                         me.name, parv[0], 
+                         me.name, parv[0],
                          host,
                          pass);
                 }
@@ -3422,9 +3449,9 @@
                 sendto_one(sptr, ":%s NOTICE %s :No aconf found",
                          me.name, parv[0]);
             }
-          else	  
+          else
           sendto_one(sptr, ":%s NOTICE %s :usage: user@host|ip",
-                     me.name, parv[0]);
+                       me.name, parv[0]);
 
           return 0;
         }
@@ -3479,8 +3506,8 @@
                    me.name, parv[0]);
     }
   else
-    sendto_one(sptr, ":%s NOTICE %s :usage: user@host|ip",
-               me.name, parv[0]);
+        sendto_one(sptr, ":%s NOTICE %s :usage: user@host|ip",
+                   me.name, parv[0]);
   return 0;
 }
 
@@ -3648,6 +3675,7 @@
     zap_Dlines();
     clear_special_conf(&x_conf);
     clear_special_conf(&u_conf);
+    clear_special_conf(&s_conf);
     clear_q_lines();
     mark_listeners_closing();
 }
diff -uNrd ircd-hybrid-6.2/src/s_debug.c ircd-hyb6.2-FEFr5/src/s_debug.c
--- ircd-hybrid-6.2/src/s_debug.c	Fri Aug 10 07:34:04 2001
+++ ircd-hyb6.2-FEFr5/src/s_debug.c	Mon Aug 20 23:32:42 2001
@@ -276,7 +276,8 @@
         }
       else
         rc++;
-      if (acptr->user)
+/*      if (acptr->user) */
+	if (IsPerson(acptr))
         {
           us++;
           for (gen_link = acptr->user->invited; gen_link;
diff -uNrd ircd-hybrid-6.2/src/s_serv.c ircd-hyb6.2-FEFr5/src/s_serv.c
--- ircd-hybrid-6.2/src/s_serv.c	Fri Jul 27 19:20:24 2001
+++ ircd-hyb6.2-FEFr5/src/s_serv.c	Tue Aug 21 02:04:43 2001
@@ -73,6 +73,7 @@
   { "QS",       CAP_QS },
   { "EX",       CAP_EX },
   { "CHW",      CAP_CHW },
+  { "FDF",	CAP_FEF },
   { 0,   0 }
 };
 
